Drag and drop / Draggable

Bootstrap drag and drop / draggable plugin

Note: We are transitioning MDB4 to a legacy version and focusing on developing MDB5. While we'll continue to support for the transition period, we encourage you to migrate to MDB5. We're offering a huge discount on MDB5 PRO to help with your transition, enabling you to leverage the full potential of the latest version. You can find more information here.
upgrade with discount

MD Bootstrap's Draggable plugin is an extension that allows you to move objects by clicking on them and dragging them anywhere within the viewport.

To start working with the Draggable plugin, see the - "Getting Started" tab on this page.


Basic example

Draggable panel

I'm a draggable panel

        
            
        <div id="draggable" class="card w-25">
          <h5 class="card-header primary-color white-text">Draggable panel</h5>
          <div class="card-body">
            <p class="card-text">I'm draggable panel</p>
          </div>
        </div>
      
        
    
        
            
        $('#draggable').draggable();
      
        
    

Auto-scroll

Use the scroll: true option to enable auto-scrolling when an element is moved beyond its container boundaries. It's also possible to change scroll sensitivity and speed with scrollSensitivity and scrollSpeed options.

Draggable panel

Drag me outside container boundary to enable auto-scroll

        
            
          <div class="row">
            <div class="col-md-4 col-6">
              <div id="draggable-scroll" class="card">
                <h5 class="card-header success-color white-text">Draggable panel</h5>
                <div class="card-body">
                  <p class="card-text">Drag me outside container boundary to enable auto-scroll</p>
                </div>
              </div>
            </div>
          </div>
        
        
    
        
            
          $('#draggable-scroll').draggable({
            scroll: true,
            scrollSensitivity: 40,
            scrollSpeed: 40
          });
        
        
    

Axis

You can limit a draggable element movement to one axis by setting either the axis: "x" or axis: "y" option.

Draggable panel

I can move only in the x-axis

Draggable panel

I can move only in the y-axis

        
            
        <div class="row">
          <div class="col-md-4 col-6">
            <div id="draggable-x" class="card">
              <h5 class="card-header primary-color white-text">Draggable panel</h5>
              <div class="card-body">
                <p class="card-text">I can move only in the x-axis </p>
              </div>
            </div>
          </div>

          <div class="col-md-4 col-6">
            <div id="draggable-y" class="card">
              <h5 class="card-header deep-orange white-text">Draggable panel</h5>
              <div class="card-body">
                <p class="card-text">I can move only in the y-axis</p>
              </div>
            </div>
          </div>
        </div>
      
        
    
        
            
        $('#draggable-x').draggable({
          axis: "x"
        });

        $('#draggable-y').draggable({
          axis: "y"
        });
      
        
    

Cursor style and position

By default, the cursor appears in the center of the dragged element. You can change the cursor style and position by specifing the cursor and cursorAt options.

Draggable panel

I have a 'move' cursor positioned in the center

Draggable panel

I have a pointer cursor positioned in the top left corner

Draggable panel

I have a crosshair cursor positioned on the bottom

        
            
        <div class="row">
          <div class="col-md-4">
            <div id="draggable-move" class="card">
              <h5 class="card-header primary-color white-text">Draggable panel</h5>
              <div class="card-body">
                <p class="card-text">I have a 'move' cursor positioned in the center</p>
              </div>
            </div>
          </div>

          <div class="col-md-4">
            <div id="draggable-pointer" class="card">
              <h5 class="card-header deep-orange white-text">Draggable panel</h5>
              <div class="card-body">
                <p class="card-text">I have a pointer cursor positioned in the top left corner</p>
              </div>
            </div>
          </div>

          <div class="col-md-4">
            <div id="draggable-crosshair" class="card">
              <h5 class="card-header success-color white-text">Draggable panel</h5>
              <div class="card-body">
                <p class="card-text">I have a crosshair cursor positioned on the bottom</p>
              </div>
            </div>
          </div>
        </div>
      
        
    
        
            
        $('#draggable-move').draggable({
          cursor: "move"
        });

        $('#draggable-pointer').draggable({
          cursor: "pointer",
          cursorAt: { top: -5, left: -5 }
        });

        $('#draggable-crosshair').draggable({
          cursor: "crosshair",
          cursorAt: { bottom: 0 }
        });
      
        
    

Handles

You can use the handle and cancel options to enable dragging only when the cursor is over a specific part of the draggable element. In the following example you can drag the card around only when the mouse cursor is over the card image.

Card image cap

Draggable card

Move the mouse over the image to drag

Button
        
            
        <div class="row">
          <div class="col-md-3">
            <!-- Card -->
            <div id="draggable-handle" class="card">

            <!-- Card image -->
            <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Others/images/43.webp" alt="Card image cap">

            <!-- Card content -->
            <div class="card-body">

            <!-- Title -->
            <h4 class="card-title"><a>Draggable card</a></h4>
            <!-- Text -->
            <p class="card-text">Move the mouse over the image to drag</p>
            <!-- Button -->
            <a href="#" class="btn btn-primary">Button</a>

            </div>

            </div>
            <!-- Card -->
        </div>
        </div>
      
        
    
        
            
        $('#draggable-handle').draggable({
          handle: '.card-img-top'
        });

        // or

        $('#draggable-handle').draggable({
          cancel: '.card-body'
        });
      
        
    

Events

There are several events that are fired when you drag en element. Start is fired at the start of the drag, drag during the dragging process, and stop when dragging stops. You can specify callback functions for those events as options.

Card image cap

Draggable card

Start event fired 0 times


Drag event fired 0 times


Stop event fired 0 times

        
            
        <div class="row">
          <div class="col-md-4">
            <!-- Card -->
            <div id="draggable-events" class="card">

            <!-- Card image -->
            <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Lightbox/Thumbnail/img%20(147).webp" alt="Card image cap">

            <!-- Card content -->
            <div class="card-body">

            <!-- Title -->
            <h4 class="card-title"><a>Draggable card</a></h4>
            <!-- Text -->
            <p class="card-text">Start event fired <span class="start-event">0</span> times</p>
            <hr>
            <p class="card-text">Drag event fired <span class="drag-event">0</span> times</p>
            <hr>
            <p class="card-text">Stop event fired <span class="stop-event">0</span> times</p>

            </div>

            </div>
            <!-- Card -->
        </div>
        </div>
      
        
    
        
            
        $('#draggable-events').draggable({
          start: onDragStart,
          drag: onDrag,
          stop: onDragStop
        });

        var $startCounter = $('.start-event');
        var $dragCounter = $('.drag-event');
        var $stopCounter = $('.stop-event');

        var counts = {
          start: 0,
          drag: 0,
          stop: 0
        };

        function onDragStart() {
          counts.start++;
          updateCounter($startCounter, counts.start);
        }

        function onDrag() {
          counts.drag++;
          updateCounter($dragCounter, counts.drag);
        }

        function onDragStop() {
          counts.stop++;
          updateCounter($stopCounter, counts.stop);
        }

        function updateCounter(selector, value) {
          $(selector).text(value);
        }
      
        
    

Snap to element

Use the snap option to snap the draggable element to another DOM element and the snapTolerance option to define the distance in pixels the draggable element must be from another element to enable snapping. There are three snap modes: inner, outer, both.

Draggable panel

I will snap to the orange panel's outer edges

Draggable panel

I will snap to the body from a distance of 50px

        
            
      <div class="container">
        <div class="row">
            <div class="col-md-4 col-6">
                <div id="draggable-snap-1" class="card">
                  <h5 class="card-header primary-color white-text">Draggable panel</h5>
                  <div class="card-body">
                    <p class="card-text">I will snap to the orange panel's outer edges</p>
                  </div>
                </div>
              </div>

              <div class="col-md-4 col-6">
                <div id="draggable-snap-2" class="card">
                  <h5 class="card-header deep-orange white-text">Draggable panel</h5>
                  <div class="card-body">
                    <p class="card-text">I will snap to the body from a distance of 50px</p>
                  </div>
                </div>
              </div>

        </div>
      </div>
      
        
    
        
            
          $('#draggable-snap-1').draggable({
            snap: '#draggable-snap-2',
            snapMode: 'outer'
          });

          $('#draggable-snap-2').draggable({
            snap: 'body',
            snapTolerance: '50'
          });
      
        
    

Revert position

When the revert option is enabled, draggable element is returned to its original position after drag stops.

Card image cap

Draggable card

Revert original card

        
            
      <div class="container">
        <div class="row">
          <div class="col-md-3">
            <!-- Card -->
            <div id="draggable-revert" class="card">

              <!-- Card image -->
              <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Others/images/49.webp" alt="Card image cap">

              <!-- Card content -->
              <div class="card-body">

                <!-- Title -->
                <h4 class="card-title"><a>Draggable card</a></h4>
                <!-- Text -->
                <p>Revert original card</p>

              </div>

            </div>
            <!-- Card -->
        </div>
      
        
    
        
            
          $('#draggable-revert').draggable({
            revert: true
          });
      
        
    

Limit draggable movement

You can set the boundaries in which draggable elements can move by using the containment option.

Draggable panel

I can only move inside the blue container

        
            
          <div class="container" style="height: 1000px">
            <div class="row h-100">
              <div class="col-md-6 blue draggable-container">
                  <div class="row">
                      <div class="col-md-6">
                        <div id="draggable-containment" class="card card-body">
                          <h4 class="card-title">Draggable panel</h4>
                          <p class="card-text">I can only move inside the blue container</p>
                      </div>
                    </div>
                  </div>
            </div>
            <div class="col-md-6 mdb-color"></div>
          </div>
      
        
    
        
            
          $('#draggable-containment').draggable({
            containment: '.draggable-container',
          });
      
        
    

Drag and drop / Draggable - getting started : download & setup


Download

This plugin requires a purchase.

Buy Draggable plugin

Tutorial

Draggable

Vue Bootstrap Draggable

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

MDB Vue Draggable plugin provides a custom directive which allows moving objects by clicking on them and dragging them anywhere within the container.

To start working with the Draggable plugin, see the - "API" tab on this page.


Basic example

        
            
            <template>
              <div class="drag-container">
                <div v-mdb-draggable class="dragged-element green"></div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
            </style>
          
        
    

Auto-scroll

Adding .scroll modifier enables auto-scrolling when element its move beyond a scroll container boundaries. In the directive's value, specify the scroll speed and scroll container's ID (if this value is undefined the directive will use the parent's parentNode ).

        
            
            <template>
              <div class="drag-container" id="scroll-container">
                <div :style="{ height: '900px', width: '120vw' }">
                  <div
                    v-mdb-draggable.scroll="{ scroll: { containerId: 'scroll-container', speed: 10 } }"
                    class="dragged-element green"
                  ></div>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                max-height: 400px;
                overflow: scroll;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
            </style>
          
        
    

Axis

Use .x and .y modifiers to enable dragging to only one axis.

X

Y

        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable.x
                  :style="{ top: '200px', left: 'calc(100% - 120px)' }"
                  class="dragged-element grey"
                >
                  <p>X</p>
                </div>
                <div v-mdb-draggable.y class="dragged-element green">
                  <p>Y</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Cursor style

By default, the cursor style is set to crosshair - you can change that by adding the cursor option in the directive's value.

Move

Pointer

        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{ cursor: 'move' }"
                  :style="{ top: '200px', left: 'calc(100% - 120px)' }"
                  class="dragged-element grey"
                >
                  <p>Move</p>
                </div>
                <div
                  v-mdb-draggable="{ cursor: 'pointer' }"
                  class="dragged-element green"
                >
                  <p>Pointer</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Handles

You can enable dragging only when the cursor is over a specific part of your element, by binding it's ID to the handle key in the directive's value object.

        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{ handle: 'drag-handle' }"
                  :style="{ top: '100px', left: '10px' }"
                  class="dragged-element grey"
                >
                  <div
                    id="drag-handle"
                    :style="{ borderRadius: '50%', width: '40%', height: '40%' }"
                    class="green"
                  ></div>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Events

You can specify custom callbacks for start, drag and end events. Additionally, the drag callback is called with two arguments - top and left values of the dragged element.

  • @start: 0
  • @drag: 0
  • @end 0
        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{
                    start: handleStart,
                    drag: handleDrag,
                    end: handleEnd
                  }"
                  class="dragged-element green"
                >
                  <ul>
                    <li>
                      @start: {{count.start}}
                    </li>
                    <li>
                      @drag: {{count.drag}}
                    </li>
                    <li>
                      @end: {{count.end}}
                    </li>
                  </ul>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                },
                data() {
                  return {
                    count: {
                      start: 0,
                      drag: 0,
                      end: 0
                    }
                  };
                },
                methods: {
                  handleStart() {
                    this.count.start++;
                  },
                  handleDrag() {
                    this.count.drag++;
                  },
                  handleEnd() {
                    this.count.end++;
                  }
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .dragged-element ul {
                padding: 0;
                list-style: none;
              }
              .dragged-element ul li {
                margin: 5px 0;
                padding: 5px 0;
                border-bottom: 1px solid rgba(0, 0, 0, 0.3);
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Snap to the container (inner mode)

Add the snap options to the directive's value in order to enable snapping to other elements/container. There are three options available:

  • tolerance (Number) - required
  • mode (String) - required, two values acceptable: inner and outer
  • referenceId (String, Array) - id of the reference element/elements - if not specified, the directive will use the parent.
        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{ snap: { tolerance: 80, mode: 'inner' } }"
                  class="dragged-element green"
                ></div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Snap to the other elements (outer mode)

        
            
            <template>
              <div class="drag-container">
                <div
                  id="el-1"
                  v-mdb-draggable="{
                    snap: { referenceId: ['el-2'], tolerance: 30, mode: 'outer' }
                  }"
                  class="dragged-element green"
                ></div>
                <div
                  id="el-2"
                  v-mdb-draggable="{
                    snap: {
                      referenceId: 'el-1',
                      tolerance: 30,
                      mode: 'outer'
                    }
                  }"
                  class="dragged-element grey"
                  :style="{ top: '250px' }"
                ></div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Revert position

To return the dragged object to its original position after dragging has ended, use the .revert modifier.

Element will return to its initial position

        
            
            <template>
              <div class="drag-container">
                <div v-mdb-draggable.revert class="dragged-element green">
                  <p>Element will return to its initial position</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
            </style>
          
        
    

Offset

You can customize offset from each container's edge, by adding offset object to the directive's value. The offset object:

  • top - offset from the top edge in px (Number, default: 0)
  • bottom - offset from the bottom edge in px (Number, default: 0)
  • left - offset from the left edge in px (Number, default: 0)
  • right - offset from the right edge in px (Number, default: 0)
        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{
                    offset: { top: 10, bottom: 30, left: 10, right: 60 }
                  }"
                  :style="{ left: 'calc(50% - 60px', top: '10px' }"
                  class="dragged-element green"
                >
                  <p>Try moving the element towards the container's edges</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Vue Draggable - getting started : download & setup


Download

This plugin requires a purchase.

Buy Draggable plugin

Modifiers

Name Description Example
.scroll Enables auto scroll <div v-mdb-draggable.scroll="{ scroll: { containerId: '..', speed: '..'}}" ></div>
.x Disables dragging along Y axis <div v-mdb-draggable.x ></div>
.y Disables dragging along X axis <div v-mdb-draggable.y ></div>
.revert Reverts the element to its original position after dragging has ended <div v-mdb-draggable.revert ></div>

Value - keys

Name Type Description Example
scroll Object Two options available: speed (Number) and containerId (String) <div v-mdb-draggable="{ scroll: { speed: 10, containerId: '..'}}" ></div>
snap Object Three options available: mode (String: 'outer' / 'inner'), referenceId (String, Array) and tolerance (Number) <div v-mdb-draggable="{ snap: { tolerance: 10, referenceId: '..', mode: 'inner'}}" ></div>
offset Object You can specify an offset in pixels (Number) from all container's edges. <div v-mdb-draggable="{ offset: { top: 10, left: 10, bottom: 30, right: 16 }}" ></div>
handle String The id of the drag-handle. <div v-mdb-draggable="{ handle: 'handle-id' }" ></div>
cursor String The cursor's style <div v-mdb-draggable="{ cursor: 'pointer' }" ></div>
parentId String The parent container's id - if not specified, the directive will use the parentNode. <div v-mdb-draggable="{ parentId: '...' }" ></div>
start Function The callback for the start event <div v-mdb-draggable="{ start: onStart }" ></div>
drag Function The callback for the drag event which will be called with two arguments: top and left values. <div v-mdb-draggable="{ drag: onDrag }" ></div>
end Function The callback for the end event <div v-mdb-draggable="{ end: onEnd }" ></div>

Example

        
            
    <template>
      <div class="drag-container" id="parent">
        <div id="el-1" v-mdb-draggable.revert.x.scroll="options" class="dragged-element green">
          <div class="handle grey" id="handle"></div>
        </div>
      </div>
    </template>
    
        
    
        
            
    <script>
      import {
        mdbDraggable
      } from "mdb-draggable";

      export default {
        directives: {
          mdbDraggable
        },
        data() {
          return {
            options: {
              scroll: {
                speed: 10,
                containerId: "../"
              },
              snap: {
                tolerance: 50,
                referenceId: "...",
                mode: "outer"
              },
              offset: {
                top: 10,
                left: 10,
                right: 70,
                bottom: 100
              },
              handle: "handle",
              parentId: "parent",
              cursor: "pointer",
              drag: () => {},
              start: () => {},
              end: () => {}
            }
          };
        }
      };
    </script>
    
        
    
        
            
    <style>
      .drag-container {
        width: 100%;
        height: 500px;
        border-radius: 5px;
        box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
        -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
      }

      .dragged-element {
        width: 100px;
        height: 100px;
        border-radius: 5px;
        font-size: 12px;
        padding: 10px;
        display: flex;
        align-items: center;
        justify-content: center;
        user-select: none;
        text-align: center;
        transition: all 0.4s linear;
        transition-property: background-color;
      }

      .handle {
        width: 30px;
        height: 30px;
        border-radius: 50%;
      }

      .green {
        background-color: rgba(76, 175, 80, 0.3);
      }

      .grey {
        background-color: rgba(96, 125, 139, 0.3);
      }
    </style>